﻿//////////////////////////////////////////////
// WindowDescriptor.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// nkMemory
#include <NilkinsMemory/Containers/String.h>

// Standards
#include <map>
#include <string>

/// Enums ------------------------------------

namespace nkGraphics
{
	enum class WINDOW_PROPS
	{
		WIDTH = 0,
		HEIGHT,
		FULLSCREEN
	} ;
}

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT WindowDescriptor final
	{
		private :
		
			// Attributs
			std::map<WINDOW_PROPS, int> _windowProperties ;
		
		public :
		
			// Constructeur, destructeur
			WindowDescriptor () ;
			~WindowDescriptor () ;

			// Getter
			int getValue (WINDOW_PROPS prop) const ;

			// Setter
			void setValue (WINDOW_PROPS prop, int value) ;

			// Print
			nkMemory::String getAsString () ;
	} ;
}